﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace scConvertToStream
{
   public partial class Form1 : Form
   {
      scConverterLib.Converter myconverter;
      public Form1()
      {
         InitializeComponent();
         myconverter = new scConverterLib.Converter();
      }

      [DllImport("ole32.dll")]
      static extern int CreateStreamOnHGlobal(IntPtr hGlobal, bool fDeleteOnRelease, out IStream ppstm);
      private void button1_Click(object sender, EventArgs e)
      {
         OpenFileDialog openFileDialog1 = new OpenFileDialog();
         openFileDialog1.Filter = "All Files|*.*";
         openFileDialog1.FilterIndex = 1;

         if (openFileDialog1.ShowDialog() == DialogResult.OK)
         {
            if (myconverter != null)
            {
               //Allocate a small buffer, it will be resized during export
               IntPtr nativePtr = Marshal.AllocHGlobal(4);
               // Create a nIStream from the allocated memory
               IStream comStream;
               CreateStreamOnHGlobal(nativePtr, true, out comStream);
               //Convert selected file to SVG
               myconverter.ConvertToStream(openFileDialog1.FileName, (scConverterLib.IStream)comStream, "SVG", 1.0, 1, 200);
               //Get size of stream after conversion
               System.Runtime.InteropServices.ComTypes.STATSTG stg;
               comStream.Stat(out stg, 1/*STATFLAG_NONAME*/);

               byte[] buf = new byte[stg.cbSize];
               //Go back to start of stream
               comStream.Seek(0, 0, IntPtr.Zero);
               //Read data and pass as text to WebBrowser
               comStream.Read(buf, (int)stg.cbSize, IntPtr.Zero);
               webBrowser1.DocumentText = Encoding.ASCII.GetString(buf);
            }
         }
      }
   }
}
